package tfg;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;

import javax.imageio.ImageIO;
import javax.swing.Icon;
import javax.swing.ImageIcon;

import org.opencv.core.Core;  
import org.opencv.core.Mat;    
import org.opencv.core.Scalar; 
import org.opencv.highgui.VideoCapture;  

import wrapper.CameraParameters;
import wrapper.Marker;
import wrapper.MarkerDetector; 

public class DetectarMarcador {  
	
	private static String niuDetectado; 
	private static Interfaz ventana  = new Interfaz();
	
	public static void main(String arg[]) throws InterruptedException, Exception {  
		// Load the native library.  
		System.loadLibrary(Core.NATIVE_LIBRARY_NAME);     
		
		//JARUCO VARIABLES
		CameraParameters CamParam = new CameraParameters();
		MarkerDetector MDetector = new MarkerDetector();
		ArrayList <Marker> Markers;
		Markers = new ArrayList<>();
		float MarkerSize = -1;

		//Open and Read from the video stream  
		Mat webcam_image=new Mat();  
		VideoCapture webCam =new VideoCapture(0);   

		GSpreadsheets google = new GSpreadsheets();
		google.inicializarGoogle();
		google.inicializarFecha();

		BaseDatos bd = new BaseDatos();
		bd.connect();
		final HashMap<String,String> niusDetectados = new HashMap<String,String>();
		
		if( webCam.isOpened()) {  
			Thread.sleep(200); /// This one-time delay allows the Webcam to initialize itself  
			while(true) {  
				webCam.read(webcam_image);  
				if( !webcam_image.empty() ) {   
					Markers.clear();

					MDetector.detect(webcam_image, Markers, CamParam, MarkerSize);

					if (Markers.size() == 5) {
						String niu = "";
						int resta = 100;
						for (int i = 0; i < Markers.size(); i++) {

							if (Markers.get(i).getId() - resta == 0) 
								niu += String.valueOf(Markers.get(i).getId() - resta) + "0";
							else if  (Markers.get(i).getId() - resta < 10) 
								niu += "0" + String.valueOf(Markers.get(i).getId() - resta);
							else
								niu += String.valueOf(Markers.get(i).getId() - resta);

							resta += 100;
							Markers.get(i).draw(webcam_image, new Scalar(0, 0, 255), 2);
						}
						if (BaseDatos.obtenerAlumno(niu)) {
							niuDetectado = niu;
							
							mostrarInfo(BaseDatos.getAlumno(), niuDetectado);
							
							ventana.getConfirmar().addActionListener(new java.awt.event.ActionListener() {
					            public void actionPerformed(java.awt.event.ActionEvent evt) {
					            	if (!niusDetectados.containsKey(niuDetectado)) {
										LongRunProcess background = new LongRunProcess(niuDetectado);
										background.execute();
										niusDetectados.put(niuDetectado, "Detectado");
									}
					            	borrarInfo();
					            }
					        });

						}
						else {
							System.out.println(" Ese alumno no existe en la base de datos.");
						}
					} 

					Thread.sleep(50); 
					
					ventana.getDetectionPanel().matToBufferedImage(webcam_image);  
					ventana.getDetectionPanel().repaint(); 
				}  
				else  {   
					System.out.println(" --(!) No captured frame from webcam !");   
					break;   
				}  
			}  
		}
		webCam.release(); 
		bd.disconnect();

	} //end main 

	static{
		System.load("/home/sara/Escritorio/TFG/aruco-1.2.4/build/src/libaruco.so.1.2");
		System.load("/home/sara/Escritorio/TFG/libWrapperCPP.so");
	}
	
	public static void mostrarInfo(Alumno alumno, String niu) throws IOException {
		
		Calendar c = Calendar.getInstance();
		String dia = Integer.toString(c.get(Calendar.DATE)); 
		String mes = Integer.toString(c.get(Calendar.MONTH) + 1); 
		String annio = Integer.toString(c.get(Calendar.YEAR));
		String fecha =  dia + "/" + mes + "/" + annio;
		
		if (alumno.getNombre() == "")
			alumno.setNombre("Este alumno no esta en la base de datos");
		
		ventana.getLabelAlumno().setText(" ·Alumno/a: " + alumno.getNombre() + " " + alumno.getApellido1() + " " + alumno.getApellido2());
		ventana.getLabelNiu().setText(" ·Niu: " + niu);
		ventana.getLabelFecha().setText(" ·Fecha: " + fecha);
		
		Image64 toolImage = new Image64();
        BufferedImage newImg = toolImage.stringToImage(alumno.getFotoCodificada());
        ImageIcon imagen = new ImageIcon(newImg);
        ImageIO.write(newImg, "jpg", new File("foto.jpg"));
        
        Icon icono = new ImageIcon(imagen.getImage().getScaledInstance(ventana.getFoto().getWidth(), 
        		ventana.getFoto().getHeight(), 
				 Image.SCALE_DEFAULT));	   
		
		ventana.getFoto().setIcon(icono);;
	}
	
	public static void borrarInfo() {
		ventana.getLabelAlumno().setText(" ·Alumno/a: ");
		ventana.getLabelNiu().setText(" ·Niu: ");
		ventana.getLabelFecha().setText(" ·Fecha: ");
		ventana.getFoto().setIcon(null);
	}
}

